######### Deterioration  -  SFS ##########################
##########################################################

########### Choose base path ################
#base_path <- "/home/rkelemen/Seafile/Work/Work/T-hap-Paper-Revisions/Data/Deterioration/PASS_SNPs/"
#base_path <- "/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/Data/Deterioration/PASS_SNPs/" ## work desktop

base_path <- "/home/rkelemen/Seafile/Work/Work/T-hap-Paper-Revisions/Data/Deterioration/raw_SNPs/"
#base_path <- "/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/Data/Deterioration/raw_SNPs/" ## work desktop
############################################

########### Choose output path ################
#output_path <- "/home/rkelemen/Seafile/Work/Work/T-hap-Paper-Revisions/DataToPlot/PASS_SNPs/DeteriorationSFS"
#output_path <- "/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/DataToPlot/PASS_SNPs/" ## work desktop

output_path <- "/home/rkelemen/Seafile/Work/Work/T-hap-Paper-Revisions/DataToPlot/raw_SNPs/DeteriorationSFS"
#output_path <- "/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/DataToPlot/raw_SNPs/" ## work desktop
############################################

########### Choose dataset ################
folder <- "DOM_NonT/"
hist.breaks <- seq(0,24,6)
############################################

path <- paste(base_path,folder,sep = "")

files <- list.files(path) ### list files in directory of interest

SFStable <- c()

syn <- c()
ns <- c()
for(sample in seq(1,length(files),4)){
  het <- read.table(paste(path,files[sample+1],sep = ""))[,1]
  hom <- read.table(paste(path,files[sample+3],sep = ""))[,1]
  syn <- c(syn,het,hom,hom) ## repeat homozygous coordinates, because those SNPs were observed on 2 chromosomes
  
  het <- read.table(paste(path,files[sample],sep = ""))[,1]
  hom <- read.table(paste(path,files[sample+2],sep = ""))[,1]
  ns <- c(ns,het,hom,hom) ## repeat homozygous coordinates, because those SNPs were observed on 2 chromosomes
}
syn.counts <- hist(table(syn),breaks=hist.breaks,plot = F)$counts
ns.counts <- hist(table(ns),breaks=hist.breaks,plot = F)$counts

SFStable <- rbind(SFStable,ns.counts,syn.counts)
dom <- ns.counts/syn.counts

########### Choose dataset ################
folder <- "SPRET/"
hist.breaks <- seq(0,16,4)
############################################

path <- paste(base_path,folder,sep = "")

files <- list.files(path) ### list files in directory of interest

syn <- c()
ns <- c()
for(sample in seq(1,length(files),4)){
  het <- read.table(paste(path,files[sample+1],sep = ""))[,1]
  hom <- read.table(paste(path,files[sample+3],sep = ""))[,1]
  syn <- c(syn,het,hom,hom) ## repeat homozygous coordinates, because those SNPs were observed on 2 chromosomes
  
  het <- read.table(paste(path,files[sample],sep = ""))[,1]
  hom <- read.table(paste(path,files[sample+2],sep = ""))[,1]
  ns <- c(ns,het,hom,hom) ## repeat homozygous coordinates, because those SNPs were observed on 2 chromosomes
}
syn.counts <- hist(table(syn),breaks=hist.breaks,plot = F)$counts
ns.counts <- hist(table(ns),breaks=hist.breaks,plot = F)$counts
spret.fixed.syn <- as.numeric(names(which(table(syn)==16)))
spret.fixed.ns <- as.numeric(names(which(table(ns)==16)))

spret <- ns.counts/syn.counts
SFStable <- rbind(SFStable,ns.counts,syn.counts)

########### Choose dataset ################
folder <- "DOM_T/"
hist.breaks <- seq(0,4)
############################################

path <- paste(base_path,folder,sep = "")

files <- list.files(path) ### list files in directory of interest

syn <- c()
ns <- c()
for(sample in seq(1,length(files),2)){
  haplotype <- read.table(paste(path,files[sample+1],sep = ""))[,1]
  syn <- c(syn,haplotype) 
  
  haplotype <- read.table(paste(path,files[sample],sep = ""))[,1]
  ns <- c(ns,haplotype) 
}
syn.counts <- hist(table(syn),breaks=hist.breaks,plot = F)$counts
ns.counts <- hist(table(ns),breaks=hist.breaks,plot = F)$counts

t.fixed.syn <- as.numeric(names(which(table(syn)==4)))
t.fixed.ns <- as.numeric(names(which(table(ns)==4)))

t <- ns.counts/syn.counts
SFStable <- rbind(SFStable,ns.counts,syn.counts)

rownames(SFStable) <- c("dom.ns","dom.syn","spret.ns","spret.syn","t.ns","t.syn")
write.table(SFStable,file = paste(output_path,"SFStable.txt",sep = ""),quote = F,col.names = F)

barplotSFS <- rbind(dom,spret,t)
write.table(barplotSFS,file = paste(output_path,"DeteriorationSFS",sep = ""),quote = F,row.names = F,col.names = F)

barplotSFS <- as.matrix((read.table(paste(output_path,"DeteriorationSFS",sep = ""))))
barplot(barplotSFS,beside = T,col=c("black","grey","green4"))


################### Deterioration in Different Ancestry Windows #######################
#######################################################################################
library(stringi)

path <- paste(getwd(),"/Seafile/Work/Work/T-hap-Paper-Revisions/Data/",sep = "")
#path <- paste(getwd(),"/Seafile/Work/T-hap-Paper-Revisions/Data/",sep = "")

f1 <- read.table(paste(path,"TreesInWindowsOf5Kb/MaximumLikelihood_IQTree/raw_SNPs/Tree_results_dom_sorted",sep = ""))
#f1 <- read.table(paste(path,"MaximumLikelihood_IQTree/PASS_SNPs/Tree_results_dom_sorted",sep = ""))
head(f1)

NR <- as.character(paste(f1[f1$V4==0,1]))
RR <- as.character(paste(f1[f1$V4==1,1]))
VR <- as.character(paste(f1[f1$V4==2,1]))

ratios <- c()

####### Routine to do for NR, RR, and VR #############
cat <- VR ## change this for one of the three categories for a run, then concatenate results to ratios object
split <- stri_split_fixed(cat,pattern = "-")
cat1 <- c()
cat2 <- c()
for(i in 1:length(cat)){
  cat1 <- c(cat1,split[[i]][1])
  cat2 <- c(cat2,split[[i]][2])
}
catDone <- cbind(as.numeric(cat1)+5000000,as.numeric(cat2)+5000000) ### adding 5000000 to the coordinates because they correspond to the 5-40 Mb region on Chr 17

t.syn <- 0
t.ns <- 0
s.syn <- 0
s.ns <- 0
for(i in 1:nrow(catDone)){
  t.syn <- t.syn + length(which(t.fixed.syn>catDone[i,1]&t.fixed.syn<catDone[i,2]))
  t.ns <- t.ns + length(which(t.fixed.ns>catDone[i,1]&t.fixed.ns<catDone[i,2]))
  s.syn <- s.syn + length(which(spret.fixed.syn>catDone[i,1]&spret.fixed.syn<catDone[i,2]))
  s.ns <- s.ns + length(which(spret.fixed.ns>catDone[i,1]&spret.fixed.ns<catDone[i,2]))
}

ratios <- rbind(ratios,c(t.ns,t.syn,s.ns,s.syn))
#############################################################

colnames(ratios) <- c("t.ns","t.syn","s.ns","s.syn")
rownames(ratios) <- c("NR","RR","VR")

write.table(ratios,file = paste(output_path,"DeteriorationTable",sep = ""),quote = F,row.names = T,col.names = T)










