######### Divergence  -  heterozygous SNPs ###############
##########################################################

########### Choose base path ################
#base_path <- "/home/rkelemen/Seafile/Work/Work/T-hap-Paper-Revisions/"
base_path <- "/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/"
############################################

########### Choose dataset ################
folder <- "Data/Divergence/PASS_SNPs/Main/"
fileSave <- "DataToPlot/PASS_SNPs/rollmeanTDivRollmeanNonT_MainDivergenceFigure"
t.files <- c(5,6,8,14)  ### file index of t-carriers
# 
# folder <- "Data/Divergence/PASS_SNPs/Controls/NeutralHeterozygosity/"
# fileSave <- "DataToPlot/PASS_SNPs/rollmeanTDivRollmeanNonT_NeutralDivergenceFigure"
# t.files <- c(5,6,8,14)  ### file index of t-carriers

# folder <- "Data/Divergence/PASS_SNPs/Controls/PseudoTvsSpretus/"
# fileSave <- "DataToPlot/PASS_SNPs/rollmeanTDivRollmeanNonT_PseudoVsSpretusDivergenceFigure"
# t.files <- 1:4  ### file index of pseudo-ts

# folder <- "Data/Divergence/PASS_SNPs/Controls/PseudoTvsSpretusNeutral/"
# fileSave <- "DataToPlot/PASS_SNPs/rollmeanTDivRollmeanNonT_PseudoVsSpretusNeutralDivergenceFigure"
# t.files <- 1:4  ### file index of pseudo-ts
# 
# folder <- "Data/Divergence/raw_SNPs/CustomCovFilter/Main/"
# fileSave <- "DataToPlot/raw_SNPs/rollmeanTDivRollmeanNonT_MainDivergenceFigure"
# t.files <- c(5,6,8,14)  ### file index of t-carriers
############################################

path <- paste(base_path,folder,sep = "")

files <- list.files(path) ### list files in directory of interest
nont.files <- setdiff((1:length(files)),t.files) ## file index of non-t-carriers

binSize <- 1000 # number of basepairs in bin
k.val <- 10^6/binSize # number of bins to take in a window of rollmean(), to end up with a rollmean window of 1 Mb

########## Non-t-carriers - compute average SNP density per Kb #############
############################################################################

density.wt.average <- rep(0,95000000/binSize)
for(i in nont.files){
  coors <- as.numeric(unlist(read.table(paste(path,files[i],sep = "")))) ### read in coordinates of snps for individual
  h <- hist((coors/binSize), breaks = seq(0,95000000/binSize,1), plot=F) #count in bins 
  density.wt.average <- density.wt.average + h$counts
}
d.mids <- h$mids
density.wt.average <- density.wt.average/length(nont.files)

########## t-carriers - compute average SNP density per Kb #############
########################################################################

density.t.average <- rep(0,95000000/binSize)
for(i in t.files){
  coors <- as.numeric(unlist(read.table(paste(path,files[i],sep = "")))) ### read in coordinates of snps for individual
  h <- hist((coors/binSize), breaks = seq(0,95000000/binSize,1), plot=F) #count in bins
  density.t.average <- density.t.average + h$counts
}
density.t.average <- density.t.average/length(t.files)


######## Compute rolling mean of t/wt heterozygosity #############
##################################################################
#install.packages("zoo")
library(zoo)

rm.x <- rollmean(d.mids,k = k.val)
rm.y1 <- rollmean(density.t.average,k = k.val)
rm.y2 <- rollmean(density.wt.average,k = k.val)

toPlot <- cbind(rm.x,rm.y1,rm.y2)

####### save to file ##########
pathToSaveTo <- paste(base_path,fileSave,sep = "")
write.table(toPlot,file = pathToSaveTo,quote = F,row.names = F,col.names = F)

plot(toPlot[,1],toPlot[,2]/toPlot[,3])



