#!/usr/bin/perl
my $input = $ARGV[0];

print "############################################\n";
print "Checking whether Ts of a species are outgroups of 1. species group 2. species\n";
print "In the output, 0 = outgroup, 1 = ingroup. Col 1 = tree name, col 2 = status regarding species group, col 3 = status regarding species\n";
print "the last column is the sum: 0 = dark green, 1 = light green, 2 = yellow\n";

open (INPUT, "$input"); 

#first we simplify the tree: 1 = Ms, 2 = Mmc, 3 = Mmm, 4 = Mmd
# 5 = Mmc t-carrier, 6 = Mmm t-carrier, 7 = Mmd t-carrier

system "cat $input | perl -pi -e \"s/\'//gi\"  | perl -pi -e \'s/ //gi\' | perl -pi -e \'s/\\///gi\' | perl -pi -e \'s/[0-9]//gi\' | perl -pi -e \'s/[\.\:\-]//gi\' | perl -pi -e \'s/[\_]//gi\' | perl -pi -e \'s/tHapl/9/gi\' | perl -pi -e \'s/Ms/1/g\' | perl -pi -e \'s/Mmc/2/g\' | perl -pi -e \'s/Mmm/3/g\' | perl -pi -e \'s/Mmd/4/g\' | perl -pi -e \'s/[a-z]//gi\' | perl -pi -e \'s/29/5/gi\' | perl -pi -e \'s/39/6/gi\' | perl -pi -e \'s/49/7/gi\' | /Users/bvicoso/Documents/Reka/Final/Submission4_Genetics/Trees/newick-utils-1.3.0/src/nw_reroot - 1   | perl -pi -e \'s/[\;\,]//gi\'  > $input.simple";


open (INPUT2, "$input.simple"); 
open (RESULTS, ">>Outgroup_results_NJ");

while ($line = <INPUT2>) {
	$text2=$line;
	}
$text=$text2;

print "$input: $text\n";


#let's check how many mice we have in the sample
@samples = split ("", $text);

$tmus=0;
$tdom=0;
$tcas=0;

$tmus_t=0;
$tdom_t=0;
$tcas_t=0;


foreach $samp (@samples)
	{ if ($samp eq "3") {$tmus=$tmus+1;}
	 elsif ($samp eq "4") {$tdom=$tdom+1;}
	 elsif ($samp eq "2") {$tcas=$tcas+1;}
	
	 elsif ($samp eq "6") {$tmus_t=$tmus_t+1;}
	 elsif ($samp eq "7") {$tdom_t=$tdom_t+1;}
	 elsif ($samp eq "5") {$tcas_t=$tcas_t+1;}

	 else {}
	}
print "total mus $tmus, dom $tdom, cas $tcas, mus-t $tmus_t, dom-t $tdom_t cas-t $tcas_t\n";


##################
#################
##################

#first test which species is outgroup FOR THE STANDARD CHROMOSOME
print "first test which species is outgroup FOR THE STANDARD CHROMOSOME\n\n";



###### 1. IS CAS THE OUTGROUP?

$counter=0;
$outgroup=N; #we assume that there is no outgroup, and change this to C/D/M if we find one

while ($counter==0)

{

#break text into blocks of bracketed expressions

@letters=split("", $text);
shift (@letters);
pop (@letters);
#print @letters;

@elements="";
$fcount=0;
$rcount=0;
foreach $letter (@letters)
	{
	push (@elements, $letter);
	if ($letter eq "(" )
		{
		$fcount=$fcount+1;
		}
	elsif ($letter eq ")" )
		{
		$rcount=$rcount+1;
		}
	else {}
	
	if ($letter ne "," && $fcount==$rcount) 
		{
		$element = join("", @elements);
		push (@blocks, $element);
		@elements="";
		$fcount=0;
		$rcount=0;

		}
	else {}
	}

#then test the blocks

foreach $block (@blocks)
	{
	if ($block =~ /3/)
		{
		$text=$block;

		$musc=0;
		$dom=0;
		$cas=0;
		$musct=0;
		$domt=0;
		$cast=0;

		#let's test whether CAS are nested in MUS+DOM
		#figure out whether block countains all Mus +DOM individuals
		#and whether it also contains CAS
		#once we get all DOM+MUS but no CAS, we can reject nesting
		
		@mice = split ("", $block);

		foreach $mouse (@mice)
			{ if ($mouse eq "3") {$musc=$musc+1;}
			 elsif ($mouse eq "4") {$dom=$dom+1;}
			 elsif ($mouse eq "2") {$cas=$cas+1;}
			 elsif ($mouse eq "6") {$musct=$musct+1;}
			 elsif ($mouse eq "7") {$domt=$domt+1;}
			 elsif ($mouse eq "5") {$cast=$cast+1;}

			 else {}
			}
print "Mice numbers t $cast m $musc c $cas d $dom\n";
		if ($musc==$tmus && $dom==$tdom) 
			{
			if ($cas==0) {$outgroup=C;print "CAS is outgroup to species group!\n";} 
			else {print " \n";}
			}
		else {$counter=1;}
		
		}
	}

@blocks="";


}



####################### 2. Is MUS outgroup?


#Let's refill $text with the full tree

$text=$text2;

print "$text\n";

$countersp=0;

while ($countersp==0)

{

#break text into blocks of bracketed expressions

@letters=split("", $text);
shift (@letters);
pop (@letters);
#print @letters;

@elements="";
$fcount=0;
$rcount=0;
foreach $letter (@letters)
	{
	push (@elements, $letter);
	if ($letter eq "(" )
		{
		$fcount=$fcount+1;
		}
	elsif ($letter eq ")" )
		{
		$rcount=$rcount+1;
		}
	else {}
	
	if ($letter ne "," && $fcount==$rcount) 
		{
		$element = join("", @elements);
		push (@blocks, $element);
		@elements="";
		$fcount=0;
		$rcount=0;

		}
	else {}
	}

#then test the blocks

foreach $block (@blocks)
	{
	if ($block =~ /2/)
		{
		$text=$block;

		$musc=0;
		$dom=0;
		$cas=0;
		$musct=0;
		$domt=0;
		$cast=0;

		#let's test whether MUS are nested in CAS+DOM 
				
		@mice = split ("", $block);

		foreach $mouse (@mice)
			{ if ($mouse eq "3") {$musc=$musc+1;}
			elsif ($mouse eq "4") {$dom=$dom+1;}
			 elsif ($mouse eq "2") {$cas=$cas+1;}
			 elsif ($mouse eq "6") {$musct=$musct+1;}
			 elsif ($mouse eq "7") {$domt=$domt+1;}
			 elsif ($mouse eq "5") {$cast=$cast+1;}

			 else {}
			}
print "Mice numbers T $cast m $musc c $cas d $dom\n";
		if ($cas==$tcas && $dom==$tdom) 
			{
			if ($musc==0) {$outgroup=M; print "MUS is outgroup to species!\n";} 
			else {" \n";}
			}
		else {$countersp=1;}
		
		}
	}

@blocks="";


}

##################################


####################### 3. Is DOM outgroup?


#Let's refill $text with the full tree

$text=$text2;

print "$text\n";

$countersp=0;

while ($countersp==0)

{

#break text into blocks of bracketed expressions

@letters=split("", $text);
shift (@letters);
pop (@letters);
#print @letters;

@elements="";
$fcount=0;
$rcount=0;
foreach $letter (@letters)
	{
	push (@elements, $letter);
	if ($letter eq "(" )
		{
		$fcount=$fcount+1;
		}
	elsif ($letter eq ")" )
		{
		$rcount=$rcount+1;
		}
	else {}
	
	if ($letter ne "," && $fcount==$rcount) 
		{
		$element = join("", @elements);
		push (@blocks, $element);
		@elements="";
		$fcount=0;
		$rcount=0;

		}
	else {}
	}

#then test the blocks

foreach $block (@blocks)
	{
	if ($block =~ /2/)
		{
		$text=$block;

		$musc=0;
		$dom=0;
		$cas=0;
		$musct=0;
		$domt=0;
		$cast=0;

		#let's test whether DOM are nested in CAS+MUS 
				
		@mice = split ("", $block);

		foreach $mouse (@mice)
			{ if ($mouse eq "3") {$musc=$musc+1;}
			elsif ($mouse eq "4") {$dom=$dom+1;}
			 elsif ($mouse eq "2") {$cas=$cas+1;}
			 elsif ($mouse eq "6") {$musct=$musct+1;}
			 elsif ($mouse eq "7") {$domt=$domt+1;}
			 elsif ($mouse eq "5") {$cast=$cast+1;}

			 else {}
			}
print "Mice numbers T $cast m $musc c $cas d $dom\n";
		if ($cas==$tcas && $musc==$tmus) 
			{
			if ($dom==0) {$outgroup=D; print "DOM is outgroup to species!\n";} 
			else {" \n";}
			}
		else {$countersp=1;}
		
		}
	}

@blocks="";


}

##################################

###NOW SAME FOR T-HAPLOTYPE

$Toutgroup=N; #Let's assume no outgroup until we find one

##################################


####################### 1. Is CAS outgroup?


#Let's refill $text with the full tree

$text=$text2;

print "$text\n";

$countersp=0;

while ($countersp==0)

{

#break text into blocks of bracketed expressions

@letters=split("", $text);
shift (@letters);
pop (@letters);
#print @letters;

@elements="";
$fcount=0;
$rcount=0;
foreach $letter (@letters)
	{
	push (@elements, $letter);
	if ($letter eq "(" )
		{
		$fcount=$fcount+1;
		}
	elsif ($letter eq ")" )
		{
		$rcount=$rcount+1;
		}
	else {}
	
	if ($letter ne "," && $fcount==$rcount) 
		{
		$element = join("", @elements);
		push (@blocks, $element);
		@elements="";
		$fcount=0;
		$rcount=0;

		}
	else {}
	}

#then test the blocks

foreach $block (@blocks)
	{
	if ($block =~ /6/)
		{
		$text=$block;

		$musc=0;
		$dom=0;
		$cas=0;
		$musct=0;
		$domt=0;
		$cast=0;

		#let's test whether t-CAS are nested in t-DOM+t-MUS 
				
		@mice = split ("", $block);

		foreach $mouse (@mice)
			{ if ($mouse eq "3") {$musc=$musc+1;}
			elsif ($mouse eq "4") {$dom=$dom+1;}
			 elsif ($mouse eq "2") {$cas=$cas+1;}
			 elsif ($mouse eq "6") {$musct=$musct+1;}
			 elsif ($mouse eq "7") {$domt=$domt+1;}
			 elsif ($mouse eq "5") {$cast=$cast+1;}

			 else {}
			}
print "Mice numbers cast $cast must $musct domt $domt\n";
		if ($domt==$tdom_t && $musct==$tmus_t) 
			{
			if ($cast==0) {$Toutgroup=C; print "CAS is outgroup to T-haplotype!\n";} 
			else {" \n";}
			}
		else {$countersp=1;}
		
		}
	}

@blocks="";


}

##################################



####################### 2. Is MUS outgroup?


#Let's refill $text with the full tree

$text=$text2;

print "$text\n";

$countersp=0;

while ($countersp==0)

{

#break text into blocks of bracketed expressions

@letters=split("", $text);
shift (@letters);
pop (@letters);
#print @letters;

@elements="";
$fcount=0;
$rcount=0;
foreach $letter (@letters)
	{
	push (@elements, $letter);
	if ($letter eq "(" )
		{
		$fcount=$fcount+1;
		}
	elsif ($letter eq ")" )
		{
		$rcount=$rcount+1;
		}
	else {}
	
	if ($letter ne "," && $fcount==$rcount) 
		{
		$element = join("", @elements);
		push (@blocks, $element);
		@elements="";
		$fcount=0;
		$rcount=0;

		}
	else {}
	}

#then test the blocks

foreach $block (@blocks)
	{
	if ($block =~ /5/)
		{
		$text=$block;

		$musc=0;
		$dom=0;
		$cas=0;
		$musct=0;
		$domt=0;
		$cast=0;

		#let's test whether t-MUS are nested in t-CAS+t-DOM 
				
		@mice = split ("", $block);

		foreach $mouse (@mice)
			{ if ($mouse eq "3") {$musc=$musc+1;}
			elsif ($mouse eq "4") {$dom=$dom+1;}
			 elsif ($mouse eq "2") {$cas=$cas+1;}
			 elsif ($mouse eq "6") {$musct=$musct+1;}
			 elsif ($mouse eq "7") {$domt=$domt+1;}
			 elsif ($mouse eq "5") {$cast=$cast+1;}

			 else {}
			}
print "Mice numbers cast $cast must $musct domt $domt\n";
		if ($domt==$tdom_t && $cast==$tcas_t) 
			{
			if ($musct==0) {$Toutgroup=M; print "MUS is outgroup to T-haplotype!\n";} 
			else {" \n";}
			}
		else {$countersp=1;}
		
		}
	}

@blocks="";


}

##################################


####################### 2. Is DOM outgroup?


#Let's refill $text with the full tree

$text=$text2;

print "$text\n";

$countersp=0;

while ($countersp==0)

{

#break text into blocks of bracketed expressions

@letters=split("", $text);
shift (@letters);
pop (@letters);
#print @letters;

@elements="";
$fcount=0;
$rcount=0;
foreach $letter (@letters)
	{
	push (@elements, $letter);
	if ($letter eq "(" )
		{
		$fcount=$fcount+1;
		}
	elsif ($letter eq ")" )
		{
		$rcount=$rcount+1;
		}
	else {}
	
	if ($letter ne "," && $fcount==$rcount) 
		{
		$element = join("", @elements);
		push (@blocks, $element);
		@elements="";
		$fcount=0;
		$rcount=0;

		}
	else {}
	}

#then test the blocks

foreach $block (@blocks)
	{
	if ($block =~ /5/)
		{
		$text=$block;

		$musc=0;
		$dom=0;
		$cas=0;
		$musct=0;
		$domt=0;
		$cast=0;

		#let's test whether t-DOM are nested in t-CAS+t-MUS 
				
		@mice = split ("", $block);

		foreach $mouse (@mice)
			{ if ($mouse eq "3") {$musc=$musc+1;}
			elsif ($mouse eq "4") {$dom=$dom+1;}
			 elsif ($mouse eq "2") {$cas=$cas+1;}
			 elsif ($mouse eq "6") {$musct=$musct+1;}
			 elsif ($mouse eq "7") {$domt=$domt+1;}
			 elsif ($mouse eq "5") {$cast=$cast+1;}

			 else {}
			}
print "Mice numbers cast $cast must $musct domt $domt\n";
		if ($musct==$tmus_t && $cast==$tcas_t) 
			{
			if ($domt==0) {$Toutgroup=D; print "MUS is outgroup to T-haplotype!\n";} 
			else {" \n";}
			}
		else {$countersp=1;}
		
		}
	}

@blocks="";


}

##################################




print RESULTS "$input $outgroup $Toutgroup\n";

