########### Set path of the DataToPlot folder ###########
#########################################################
#########################################################

#path <- "/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/DataToPlot/PASS_SNPs/"
path <- "/home/rkelemen/Seafile/Work/Work/T-hap-Paper-Revisions/DataToPlot/PASS_SNPs/"

#########################################################
#########################################################

##################################################
############# Divergence Plot ####################
##################################################
toPlot <- read.table(paste(path,"rollmeanTDivRollmeanNonT_MainDivergenceFigure",sep = "")) ### load data
barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_DOM",sep = "")))
cnvCoverage <- read.table(paste(path,"CNVCoverageInHalfMbWindows",sep = ""))$V1/500000 ## get proportion of window covered by CNVs
t2g <- read.table("/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/DataToPlot/PASS_SNPs/GenePositionInfo",header = T)

sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
colnames(barplot.input) <- c()

gn1 <- c("Dynlt1a*","Dynlt1b","Dynlt1c*",  "Dynlt1f*","Tagap1")  # vector of gene names in inversion 1, * means significantly diff expressed
gn2 <- c("T","Qk",  "Map3k4*","Slc22a3*", "Igf2r","Tcp1","Sod2")  # vector of gene names in inversion 2
gnBtwn2And3 <- c( "Tcp10b*", "Tcp10c", "Smok2a")
gn3 <- c("Tcte2*","Tcte3","Tbp*","Prdm9")  # vector of gene names in inversion 3
gn4 <- c("Nme3", "Hmga1*","Pim1","Bag6*","Znrd1as","Olfr128*")  # vector of gene names in inversion 4
gn.list <- list(gn1,gn2,gn3,gn4)

binSize <- 1000
par(mfrow=c(1,1),mar=c(4,4,1,4),cex=1.3)

plot(barplot.input[1,],xlim=c(-10,180),axes=F,type = "h",lwd=6, ylim=c(-0.23,2.1),
     col=ifelse(barplot.input[1,]>0,"darkseagreen3","white"), xlab="",ylab="")
axis(4, at = seq(0,1,0.25),labels = c(0,0.25,0.5,0.75,1), col="darkseagreen3")
mtext(text = "Phylogenetic divergence",side = 4, line=2.6, at=0.5, cex=1.3)
par(new=T)

plot(cnvCoverage,xlim=c(-10,180),axes=F,type = "h",lwd=6, ylim=c(0,14),
     col=ifelse(cnvCoverage>0,"light grey","white"), xlab="",ylab="")
axis(4, at = seq(0,1), col="light grey")
mtext(text = "CNV", side=4,at = 0.5, line = 2.6, cex=1.3)
par(new=T)
y.lim <- c(-2,16.5)

plot(toPlot[,1],toPlot[,2]/toPlot[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "",ylim=y.lim, xlim=c(0,95000000/binSize))
axis(1,at = seq(5000000/binSize,95000000/binSize,5000000/binSize), labels = seq(5,95,5))
axis(2,at=seq(0,14,2))
title(ylab = "Excess heterozygosity of t-carriers")
title(xlab = "Position on Chr17 (Mb)")

col.vec <- rep("green4",4)
for(i in 1:4){
  inv.positions <- c()
  for(j in 1:length(gn.list[[i]])){
    inv.positions <- c(inv.positions,(t2g[t2g$ext_gene==stri_split_fixed(gn.list[[i]][j],"*")[[1]][1],3][1])/binSize)
  }
  par(new=T)
  plot(x=c(min(inv.positions),max(inv.positions)), y=rep(y.lim[2]-0.5,2), type = "l", xlab = "", col="black",
       ylab = "", lwd=8, lty=1,
       main="", xlim=c(0,95000000/binSize), ylim=y.lim, axes=F)
  par(new=T)
  plot(x=c(min(inv.positions),max(inv.positions)), y=rep(y.lim[2]-0.5,2), type = "l", xlab = "", col=col.vec[i],
       ylab = "", lwd=5.5, lty=1,
       main="", xlim=c(0,95000000/binSize), ylim=y.lim, axes=F)
  text(mean(c(min(inv.positions),max(inv.positions))),y.lim[2]-0.5,paste("Inv",i,sep = ""),pos = 3,font = 4, cex=0.8)
}
mtext("Nme3",at = t2g[t2g$ext_gene=="Nme3",3][1]/binSize,las=3, line=-2, cex=0.9, font=1, adj = 1, col="green4")
mtext("Fgd2",at = t2g[t2g$ext_gene=="Fgd2",3][1]/binSize,las=3, line=-2, cex=0.9, font=1, adj=1, col="green4")
mtext("Tagap1",at = t2g[t2g$ext_gene=="Tagap1",3][1]/binSize,las=3, line=-2, cex=0.9, font=1, adj=1, col="green4")
mtext("Smok2a",at = t2g[t2g$ext_gene=="Smok2a",3][1]/binSize,las=3, line=-2, cex=0.9, font=2,adj=1, col="green4")


##########################################################################
##################### 5 Kb Trees #########################################
##########################################################################
# install.packages("ape")
library(ape)
vr.col <- "darkgoldenrod1"
rr.col <- "light green"
nr.col <- "green4"
layout(matrix(c(1,2,3,4,4,4,5,5,5,6,6,6), 4, 3, byrow = TRUE), heights=c(2,1,1,1))
#par(mfrow=c(1,3))

treePhylo<-read.tree(file =paste(path,"TreeNonRecombined_2460000-2465000.fa.contree",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Hapl",treePhylo$tip.label)] <- nr.col
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")
par(mar=rep(0.5,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),align.tip.label = 2,
           edge.width = 2,tip.color = col.vec,cex=0.9,font = 1)
##########################
treePhylo<-read.tree(file =paste(path,"TreeRecentlyRecombined_795000-800000.fa.contree",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Hapl",treePhylo$tip.label)] <- rr.col
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")
par(mar=rep(0.5,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),align.tip.label = 2,
           edge.width = 2,tip.color = col.vec,cex=0.9,font = 1)
##########################
treePhylo<-read.tree(file =paste(path,"TreeVeryRecentlyRecombined_0-5000.fa.contree",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Hapl",treePhylo$tip.label)] <- vr.col
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")
par(mar=rep(0.5,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),align.tip.label = 2,
           edge.width = 2,tip.color = col.vec,cex=0.9,font = 1)


############# Barplot of tree support summary ######################
#par(mfrow=c(3,1), mar=c(1,1.4,1.4,1))

par(cex=1.5)
barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_DOM",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "DOM",line = -0.5)
#title(main = "DOM", cex.main=2)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_CAS",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "CAS",line = -0.5)
#title(main = "CAS", cex.main=2)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_MUS",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "MUS",line = -0.5)
#title(main = "MUS", cex.main=2)

##################################################################################
######################### Non-recombined regions tree ############################
##################################################################################
# install.packages("ape")
library(ape)
dom.col <- "darkgoldenrod1"
cast.col <- "red"
musc.col <- "coral"
t.col <- "green4"

layout(matrix(c(2,1,3,1,4,4),3,2,byrow = T),widths = c(1,1),heights = c(1,1,1.7))

############# tree of non-recombined windows 

treePhylo<-read.tree(file =paste(path,"TreeOfNonRecombinedRegions.fa.contree",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Mmm",treePhylo$tip.label)] <- musc.col #musculus 
col.vec[grep("Mmc",treePhylo$tip.label)] <- cast.col #castaneus 
col.vec[grep("Mmd",treePhylo$tip.label)] <- dom.col #domesticus 
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")

par(mar=rep(0.1,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),edge.width = 2,
           tip.color = col.vec,cex=1.4,font = 4,align.tip.label = 2)
nodelabels(text = treePhylo$node.label,cex=0.75,frame = "none",adj = 1.3, col="ivory4")


########## toy tree 1
treePhylo<-read.tree(file =paste(path,"ToyTree1",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Mmm",treePhylo$tip.label)] <- musc.col #musculus 
col.vec[grep("Mmc",treePhylo$tip.label)] <- cast.col #castaneus 
col.vec[grep("Mmd",treePhylo$tip.label)] <- dom.col #domesticus 
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")

par(mar=rep(0.9,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),edge.width = 1
           ,tip.color = col.vec,cex=1.4,font = 4, align.tip.label = F)

####### toy tree 2 
treePhylo<-read.tree(file =paste(path,"ToyTree2",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Mmm",treePhylo$tip.label)] <- musc.col #musculus 
col.vec[grep("Mmc",treePhylo$tip.label)] <- cast.col #castaneus 
col.vec[grep("Mmd",treePhylo$tip.label)] <- dom.col #domesticus 
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")

par(mar=rep(0.9,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),edge.width = 1
           ,tip.color = col.vec,cex=1.4,font = 4, align.tip.label = F)

###########################################
########## outgroup barplot ###############
###########################################

outgroup <- read.table(paste(path,"Outgroup_results_ML",sep = ""))[,2:3]
par(mar=c(6,4,1,1), cex=1.4)
barplot(rbind(table(outgroup[,1])[c(4,2,1,3)]*100/sum(table(outgroup[,1])),table(outgroup[,2])[c(4,2,1,3)]*100/sum(table(outgroup[,1]))),
        beside = T, col=c("grey","green4"),xlab = "Outgroup", ylab = "Percent of trees", cex.lab=1.1,names.arg = c("None", 
                                                                                                                   expression(italic("M. m. domesticus")),
                                                                                                                   expression(italic("M. m. castaneus")),
                                                                                                                   expression(italic("M. m. musculus"))),
        cex.names = 1.15)

##########################################################################
##################### Deterioration ######################################
##########################################################################
barplotSFS <- as.matrix((read.table(paste(path,"DeteriorationSFS",sep = ""))))
deteriorCateg <- read.table(paste(path,"DeteriorationTable",sep = ""))
ratios <- rbind((deteriorCateg$t.ns/deteriorCateg$t.syn),deteriorCateg$s.ns/deteriorCateg$s.syn)

par(mfrow=c(1,2), mar=c(4.5,5,1,1), cex=1.5)
barplot(barplotSFS,beside = T,col=c("grey","black","green4"), ylim=c(0,1.1),
        names.arg = c("0.25", "0.5", "0.75", "1"),
        xlab = "Proportion of haplotypes carrying SNP",
        ylab = "NS / S SNP ratio",
        args.legend = list(bty="n",x=43, y=1.1,x.intersp=0.1), 
        legend.text = c(expression(italic("M. m. domesticus")),
                        expression(italic("M. spretus")),
                        expression(paste(italic("t"),"-haplotype (",italic("M. m. d."),")"))
        ))
barplot(ratios,col=c("green4","black"), ylim=c(0,1.1),
        names.arg = c("None", "Recent","Very Recent"), xlab = "Recombination", 
        ylab = "NS / S fixed SNP ratio", beside = T)

