########### Set path of the DataToPlot folder ###########
#########################################################
#########################################################

#path <- "/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/DataToPlot/PASS_SNPs/"
path <- "/home/rkelemen/Seafile/Work/Work/T-hap-Paper-Revisions/DataToPlot/PASS_SNPs/"

#########################################################
#########################################################

################################################################
############# Supplementary Divergence Plot ####################
################################################################
par(mfrow=c(3,2),mar=c(4,5,1,1),cex=0.73)

toPlot <- read.table(paste(path,"rollmeanTDivRollmeanNonT_MainDivergenceFigure",sep = "")) ### load data
t2g <- read.table(paste(path,"GenePositionInfo",sep = ""),header = T)

gn1 <- c("Dynlt1a*","Dynlt1b","Dynlt1c*",  "Dynlt1f*","Tagap1")  # vector of gene names in inversion 1, * means significantly diff expressed
gn2 <- c("T","Qk",  "Map3k4*","Slc22a3*", "Igf2r","Tcp1","Sod2")  # vector of gene names in inversion 2
gnBtwn2And3 <- c( "Tcp10b*", "Tcp10c", "Smok2a")
gn3 <- c("Tcte2*","Tcte3","Tbp*","Prdm9")  # vector of gene names in inversion 3
gn4 <- c("Nme3", "Hmga1*","Pim1","Bag6*","Znrd1as","Olfr128*")  # vector of gene names in inversion 4
gn.list <- list(gn1,gn2,gn3,gn4)

binSize <- 1000

y.lim <- c(0,20.5)

plot(toPlot[,1],toPlot[,2]/toPlot[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "",ylim=y.lim, xlim=c(0,95000000/binSize))
axis(1,at = seq(5000000/binSize,95000000/binSize,5000000/binSize), labels = seq(5,95,5))
axis(2,at=seq(0,y.lim[2]-4.5,2))
title(ylab = expression(paste("Excess heterozygosity of ",italic("t"),"-carriers")))

col.vec <- rep("green4",4)
for(i in 1:4){
  inv.positions <- c()
  for(j in 1:length(gn.list[[i]])){
    inv.positions <- c(inv.positions,(t2g[t2g$ext_gene==stri_split_fixed(gn.list[[i]][j],"*")[[1]][1],3][1])/binSize)
  }
  par(new=T)
  plot(x=c(min(inv.positions),max(inv.positions)), y=rep(y.lim[2]-0.7,2), type = "l", xlab = "", col="grey",
       ylab = "", lwd=7, lty=1,
       main="", xlim=c(0,95000000/binSize), ylim=y.lim, axes=F)
  par(new=T)
  plot(x=c(min(inv.positions),max(inv.positions)), y=rep(y.lim[2]-0.7,2), type = "l", xlab = "", col=col.vec[i],
       ylab = "", lwd=5.5, lty=1,
       main="", xlim=c(0,95000000/binSize), ylim=y.lim, axes=F)
  text(mean(c(min(inv.positions),max(inv.positions))),y.lim[2]-0.7,paste("Inv",i,sep = ""),pos = 3,font = 4, cex=0.8)
}
mtext("Nme3",at = t2g[t2g$ext_gene=="Nme3",3][1]/binSize,las=3, line=-1.3, cex=0.7, font=1, adj = 1, col="green4")
mtext("Fgd2",at = t2g[t2g$ext_gene=="Fgd2",3][1]/binSize,las=3, line=-1.3, cex=0.7, font=1, adj=1, col="green4")
mtext("Tagap1",at = t2g[t2g$ext_gene=="Tagap1",3][1]/binSize,las=3, line=-1.3, cex=0.7, font=1, adj=1, col="green4")
mtext("Smok2a",at = t2g[t2g$ext_gene=="Smok2a",3][1]/binSize,las=3, line=-1.3, cex=0.7, font=2,adj=1, col="green4")

############# Neutral Divergence Plot ####################
##########################################################
toPlot <- read.table(paste(path,"rollmeanTDivRollmeanNonT_NeutralDivergenceFigure",sep = "")) ### load data

plot(toPlot[,1],toPlot[,2]/toPlot[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "", ylim=y.lim)
axis(1,at = seq(5000000/binSize,95000000/binSize,5000000/binSize), labels = seq(5,95,5))
axis(2,at=seq(0,y.lim[2]-4.5,2))
title(ylab = expression(paste("Excess neutral het. of ",italic("t"),"-carriers")),cex=0.7)

col.vec <- rep("green4",4)
for(i in 1:4){
  inv.positions <- c()
  for(j in 1:length(gn.list[[i]])){
    inv.positions <- c(inv.positions,(t2g[t2g$ext_gene==stri_split_fixed(gn.list[[i]][j],"*")[[1]][1],3][1])/binSize)
  }
  par(new=T)
  plot(x=c(min(inv.positions),max(inv.positions)), y=rep(y.lim[2]-0.7,2), type = "l", xlab = "", col="grey",
       ylab = "", lwd=7, lty=1,
       main="", xlim=c(0,95000000/binSize), ylim=y.lim, axes=F)
  par(new=T)
  plot(x=c(min(inv.positions),max(inv.positions)), y=rep(y.lim[2]-0.7,2), type = "l", xlab = "", col=col.vec[i],
       ylab = "", lwd=5.5, lty=1,
       main="", xlim=c(0,95000000/binSize), ylim=y.lim, axes=F)
  text(mean(c(min(inv.positions),max(inv.positions))),y.lim[2]-0.7,paste("Inv",i,sep = ""),pos = 3,font = 4, cex=0.8)
}
############# Pseudo-t vs Spretus Divergence Plot ####################
######################################################################
toPlot <- read.table(paste(path,"rollmeanTDivRollmeanNonT_PseudoVsSpretusDivergenceFigure",sep = "")) ### load data

plot(toPlot[,1],toPlot[,2]/toPlot[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "", ylim=c(0,0.9))
axis(1,at = seq(5000000/binSize,95000000/binSize,5000000/binSize), labels = seq(5,95,5))
axis(2)
title(ylab = expression(paste(italic("t"),"-haplotype / ",italic("M. spretus"), " divergence")))

############# Pseudo-t vs Neutral Spretus Divergence Plot ####################
######################################################################
toPlot <- read.table(paste(path,"rollmeanTDivRollmeanNonT_PseudoVsSpretusNeutralDivergenceFigure",sep = "")) ### load data

plot(toPlot[,1],toPlot[,2]/toPlot[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "", ylim=c(0,0.9))
axis(1,at = seq(5000000/binSize,95000000/binSize,5000000/binSize), labels = seq(5,95,5))
axis(2)
title(ylab = expression(paste(italic("t"),"-haplotype / ",italic("M. spretus"), " neutral divergence")))

############# Pseudo-t vs Spretus Divergence Plot - separate ####################
#################################################################################
toPlot <- read.table(paste(path,"rollmeanTDivRollmeanNonT_PseudoVsSpretusDivergenceFigure",sep = "")) ### load data
toPlot2 <- read.table(paste(path,"rollmeanTDivRollmeanNonT_MainDivergenceFigure",sep = "")) ### load data

y.lim <- c(0,30)
plot(toPlot2[,1],toPlot2[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "", ylim = y.lim,col="grey")
par(new=T)
plot(toPlot[,1],toPlot[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "", ylim = y.lim)
par(new=T)
plot(toPlot[,1],toPlot[,2],type = "l",axes=F,lwd=3, xlab="", ylab = "", col="green4", ylim=y.lim)
axis(1,at = seq(5000000/binSize,95000000/binSize,5000000/binSize), labels = seq(5,95,5))
axis(2)
title(ylab = "Divergence")
title(xlab = "Position on Chr17 (Mb)")
legend(0.55*(10^8)/binSize,32,legend = c(expression(italic("M. m. domesticus")),expression(italic("M. spretus")),expression(paste(italic("t"),"-haplotype"))),
       bty="n",lwd=3,col=c("grey","black","green4"),x.intersp = 0.5, y.intersp = 0.5,cex = 1,seg.len = 0.5)


############# Pseudo-t vs Spretus Neutral Divergence Plot - separate ####################
#########################################################################################
toPlot <- read.table(paste(path,"rollmeanTDivRollmeanNonT_PseudoVsSpretusNeutralDivergenceFigure",sep = "")) ### load data
toPlot2 <- read.table(paste(path,"rollmeanTDivRollmeanNonT_NeutralDivergenceFigure",sep = "")) ### load data

plot(toPlot2[,1],toPlot2[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "", ylim = y.lim,col="grey")
par(new=T)
plot(toPlot[,1],toPlot[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "", ylim = y.lim)
par(new=T)
plot(toPlot[,1],toPlot[,2],type = "l",axes=F,lwd=3, xlab="", ylab = "", col="green4", ylim=y.lim)
axis(1,at = seq(5000000/binSize,95000000/binSize,5000000/binSize), labels = seq(5,95,5))
axis(2)
title(ylab = "Neutral divergence")
title(xlab = "Position on Chr17 (Mb)")
legend(0.55*(10^8)/binSize,32,legend = c(expression(italic("M. m. domesticus")),expression(italic("M. spretus")),expression(paste(italic("t"),"-haplotype"))),
       bty="n",lwd=3,col=c("grey","black","green4"),x.intersp = 0.5, seg.len = 0.5, y.intersp = 0.5,cex = 1)


##########################################################################
##################### 5 Kb Trees #########################################
##########################################################################
# install.packages("ape")
library(ape)

############ Maximum parsiomny results ######################
par(mfrow=c(3,2), mar=c(0.1,1,0.1,0.1), cex=1.6)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_DOM_MP",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "DOM",line = -0.5)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_DOM_NJ",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_CAS_MP",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "CAS",line = -0.5)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_CAS_NJ",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_MUS_MP",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "MUS",line = -0.5)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_MUS_NJ",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)


#################################################################################################
######################### Non-recombined regions tree - STAR TOPOLOGY ###########################
#################################################################################################
treePhylo<-read.tree(file =paste(path,"TreeOfNonRecombinedRegionsSTAR_TOPOLOGY.fa.contree",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Mmm",treePhylo$tip.label)] <- musc.col #musculus 
col.vec[grep("Mmc",treePhylo$tip.label)] <- cast.col #castaneus 
col.vec[grep("Mmd",treePhylo$tip.label)] <- dom.col #domesticus 
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")

par(mar=rep(0.5,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),edge.width = 2,adj = 0.5,tip.color = col.vec,cex=0.9,font = 4)
nodelabels(text = treePhylo$node.label,cex=0.75,frame = "none",adj = 1.3, col="ivory4")


#################################################################################################
######################### Non-recombined regions tree - private SNPs ############################
#################################################################################################
# install.packages("ape")
layout(matrix(c(1,2,3,3,4,4),3,2,byrow = T),heights = c(2,1,1))
library(ape)
dom.col <- "darkgoldenrod1"
cast.col <- "red"
musc.col <- "coral"
t.col <- "green4"

treePhylo<-read.tree(file =paste(path,"Chr17_60-80Mb.fa.contree",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Mmm",treePhylo$tip.label)] <- musc.col #musculus 
col.vec[grep("Mmc",treePhylo$tip.label)] <- cast.col #castaneus 
col.vec[grep("Mmd",treePhylo$tip.label)] <- dom.col #domesticus 
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")

par(mar=rep(0.9,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),align.tip.label = 3,edge.width = 1.5,adj = 0.5,tip.color = col.vec,cex=0.9,font = 4)
nodelabels(text = treePhylo$node.label,cex=0.75,frame = "none",adj = 1.3, col="ivory4")

###################################################################################
######################### Chr17:60-80Mb - private SNPs ############################
###################################################################################

treePhylo<-read.tree(file =paste(path,"TreeOfNonRecombinedRegions_PrivateHETSNPsOnly.fa.contree",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Mmm",treePhylo$tip.label)] <- musc.col #musculus 
col.vec[grep("Mmc",treePhylo$tip.label)] <- cast.col #castaneus 
col.vec[grep("Mmd",treePhylo$tip.label)] <- dom.col #domesticus 
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")

par(mar=rep(0.9,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),align.tip.label = 3,edge.width = 1.5,adj = 0.5,tip.color = col.vec,cex=0.9,font = 4)
nodelabels(text = treePhylo$node.label,cex=0.75,frame = "none",adj = 1.3, col="ivory4")

################################################################################################################################################
########## Outgroup barplots CONTROLS 1 and 2 - Tree topologies based on private SNPs t complex and rest of Chr17 ##############################
################################################################################################################################################
par(mar=c(5,4,1,1),cex=1.2)
outgroup <- read.table(paste(path,"Outgroup_results_ML_CONTROL1_50to90Mb",sep = ""))[,2:3]
barplot(rbind(table(outgroup[,1])[c(4,2,1,3)]*100/sum(table(outgroup[,1])),c(table(outgroup[,2])[2],0,table(outgroup[,2])[1],0)*100/sum(table(outgroup[,1]))),
        beside = T, col=c("grey","green4"), ylab = "Percent of trees", cex.lab=1.2,names.arg = c("None", 
                                                                                                 expression(italic("M. m. domesticus")),
                                                                                                 expression(italic("M. m. castaneus")),
                                                                                                 expression(italic("M. m. musculus"))),
        cex.names = 1.1)

outgroup <- read.table(paste(path,"Outgroup_results_ML_CONTROL2_PrivateHetSNPs",sep = ""))[,2:3]
barplot(rbind(table(outgroup[,1])[c(4,2,1,3)]*100/sum(table(outgroup[,1])),table(outgroup[,2])[c(4,2,1,3)]*100/sum(table(outgroup[,1]))),
        beside = T, col=c("grey","green4"),xlab = "Outgroup", ylab = "Percent of trees", cex.lab=1.2,names.arg = c("None", 
                                                                                                                   expression(italic("M. m. domesticus")),
                                                                                                                   expression(italic("M. m. castaneus")),
                                                                                                                   expression(italic("M. m. musculus"))),
        cex.names = 1.1)



#################################################################################################################
######################### Non-recombined regions tree - private SNPs - STAR TOPOLOGY ############################
#################################################################################################################
# install.packages("ape")
library(ape)
dom.col <- "darkgoldenrod1"
cast.col <- "red"
musc.col <- "coral"
t.col <- "green4"

treePhylo<-read.tree(file =paste(path,"TreeOfNonRecombinedRegions_PrivateHETSNPsOnly_STAR_TOPOLOGY.fa.contree",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Mmm",treePhylo$tip.label)] <- musc.col #musculus 
col.vec[grep("Mmc",treePhylo$tip.label)] <- cast.col #castaneus 
col.vec[grep("Mmd",treePhylo$tip.label)] <- dom.col #domesticus 
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")

par(mar=rep(0.5,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),edge.width = 2,adj = 0.5,tip.color = col.vec,cex=0.9,font = 4)
nodelabels(text = treePhylo$node.label,cex=0.75,frame = "none",adj = 1.3, col="ivory4")


##########################################################################################################
########## Outgroup barplots Maximum Parsimony and Neighbor Joining methods ##############################
##########################################################################################################
par(mar=c(4.2,4,1,1), mfrow=c(2,1), cex=1.2)

outgroup <- read.table(paste(path,"Outgroup_results_MP",sep = ""))[,2:3]
barplot(rbind(table(outgroup[,1])[c(4,2,1,3)]*100/sum(table(outgroup[,1])),table(outgroup[,2])[c(4,2,1,3)]*100/sum(table(outgroup[,1]))),
        beside = T, col=c("grey","green4"), ylab = "Percent of trees", cex.lab=1.1,names.arg = c("None", 
                                                                                                                   expression(italic("M. m. domesticus")),
                                                                                                                   expression(italic("M. m. castaneus")),
                                                                                                                   expression(italic("M. m. musculus"))),
        legend.text = c(expression(paste("Non-",italic("t"),"-haplotypes")),expression(paste(italic("t"),"-haplotypes"))),args.legend = list(bty="n", cex=1.2), cex.names = 1.1)

outgroup <- read.table(paste(path,"Outgroup_results_NJ",sep = ""))[,2:3]
barplot(rbind(table(outgroup[,1])[c(4,2,1,3)]*100/sum(table(outgroup[,1])),table(outgroup[,2])[c(4,2,1,3)]*100/sum(table(outgroup[,1]))),
        beside = T, col=c("grey","green4"),xlab = "Outgroup", ylab = "Percent of trees", cex.lab=1.1,names.arg = c("None", 
                                                                                                                   expression(italic("M. m. domesticus")),
                                                                                                                   expression(italic("M. m. castaneus")),
                                                                                                                   expression(italic("M. m. musculus"))),
        legend.text = c(expression(paste("Non-",italic("t"),"-haplotypes")),expression(paste(italic("t"),"-haplotypes"))),args.legend = list(bty="n", cex=1.2), cex.names = 1.1)


