########### Set path of the DataToPlot folder ###########
#########################################################
#########################################################

######## Raw coverage filtered SNPs ############
################################################
#path <- "/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/DataToPlot/raw_SNPs/"
path <- "/home/rkelemen/Seafile/Work/Work/T-hap-Paper-Revisions/DataToPlot/raw_SNPs/"
#########################################################
#########################################################


############# Divergence Plot ####################
##################################################
toPlot <- read.table(paste(path,"rollmeanTDivRollmeanNonT_MainDivergenceFigure",sep = "")) ### load data
barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_DOM",sep = "")))
cnvCoverage <- read.table(paste(path,"CNVCoverageInHalfMbWindows",sep = ""))$V1/500000 ## get proportion of window covered by CNVs
t2g <- read.table("/Users/rkelemen/Seafile/Work/T-hap-Paper-Revisions/DataToPlot/PASS_SNPs/GenePositionInfo",header = T)

sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
colnames(barplot.input) <- c()

gn1 <- c("Dynlt1a*","Dynlt1b","Dynlt1c*",  "Dynlt1f*","Tagap1")  # vector of gene names in inversion 1, * means significantly diff expressed
gn2 <- c("T","Qk",  "Map3k4*","Slc22a3*", "Igf2r","Tcp1","Sod2")  # vector of gene names in inversion 2
gnBtwn2And3 <- c( "Tcp10b*", "Tcp10c", "Smok2a")
gn3 <- c("Tcte2*","Tcte3","Tbp*","Prdm9")  # vector of gene names in inversion 3
gn4 <- c("Nme3", "Hmga1*","Pim1","Bag6*","Znrd1as","Olfr128*")  # vector of gene names in inversion 4
gn.list <- list(gn1,gn2,gn3,gn4)

binSize <- 1000
par(mfrow=c(1,1),mar=c(4,4,1,4),cex=1.3)

plot(barplot.input[1,],xlim=c(-10,180),axes=F,type = "h",lwd=6, ylim=c(-0.2,1.5),
     col=ifelse(barplot.input[1,]>0,"darkseagreen3","white"), xlab="",ylab="")
axis(4, at = seq(0,1,0.25),labels = c(0,0.25,0.5,0.75,1), col="darkseagreen3")
mtext(text = "Phylogenetic divergence",side = 4, line=2.6, at=0.5, cex=1.3)
par(new=T)

plot(cnvCoverage,xlim=c(-10,180),axes=F,type = "h",lwd=6, ylim=c(0,14),
     col=ifelse(cnvCoverage>0,"light grey","white"), xlab="",ylab="")
axis(4, at = seq(0,1), col="light grey")
mtext(text = "CNV", side=4,at = 0.5, line = 2.6, cex=1.3)
par(new=T)
y.lim <- c(-2,14.5)

plot(toPlot[,1],toPlot[,2]/toPlot[,3],type = "l",axes=F,lwd=3, xlab="", ylab = "",ylim=y.lim, xlim=c(0,95000000/binSize))
axis(1,at = seq(5000000/binSize,95000000/binSize,5000000/binSize), labels = seq(5,95,5))
axis(2,at=seq(0,y.lim[2]-2.5,2))
title(ylab = "Excess heterozygosity of t-carriers")
title(xlab = "Position on Chr17 (Mb)")

col.vec <- rep("green4",4)
for(i in 1:4){
  inv.positions <- c()
  for(j in 1:length(gn.list[[i]])){
    inv.positions <- c(inv.positions,(t2g[t2g$ext_gene==stri_split_fixed(gn.list[[i]][j],"*")[[1]][1],3][1])/binSize)
  }
  par(new=T)
  plot(x=c(min(inv.positions),max(inv.positions)), y=rep(y.lim[2]-0.5,2), type = "l", xlab = "", col="black",
       ylab = "", lwd=8, lty=1,
       main="", xlim=c(0,95000000/binSize), ylim=y.lim, axes=F)
  par(new=T)
  plot(x=c(min(inv.positions),max(inv.positions)), y=rep(y.lim[2]-0.5,2), type = "l", xlab = "", col=col.vec[i],
       ylab = "", lwd=5.5, lty=1,
       main="", xlim=c(0,95000000/binSize), ylim=y.lim, axes=F)
  text(mean(c(min(inv.positions),max(inv.positions))),y.lim[2]-0.5,paste("Inv",i,sep = ""),pos = 3,font = 4, cex=0.8)
}
mtext("Nme3",at = t2g[t2g$ext_gene=="Nme3",3][1]/binSize,las=3, line=-2.5, cex=0.9, font=1, adj = 1, col="green4")
mtext("Fgd2",at = t2g[t2g$ext_gene=="Fgd2",3][1]/binSize,las=3, line=-2.5, cex=0.9, font=1, adj=1, col="green4")
mtext("Tagap1",at = t2g[t2g$ext_gene=="Tagap1",3][1]/binSize,las=3, line=-2.5, cex=0.9, font=1, adj=1, col="green4")
mtext("Smok2a",at = t2g[t2g$ext_gene=="Smok2a",3][1]/binSize,las=3, line=-2.5, cex=0.9, font=2,adj=1, col="green4")


##########################################################################
##################### 5 Kb Trees #########################################
##########################################################################

############ Maximum likelihood results ######################
par(mfrow=c(3,1), mar=c(1,1.4,1.4,1))

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_DOM",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "DOM",line = -0.5)
#title(main = "DOM", cex.main=2)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_CAS",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "CAS",line = -0.5)
#title(main = "CAS", cex.main=2)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_MUS",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "MUS",line = -0.5)


############ Maximum parsiomny results ######################
par(mfrow=c(3,1), mar=c(1,1.4,1.4,1))

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_DOM_MP",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "DOM",line = -0.5)
#title(main = "DOM", cex.main=2)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_CAS_MP",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "CAS",line = -0.5)
#title(main = "CAS", cex.main=2)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_MUS_MP",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "MUS",line = -0.5)


############ Neighbor-joining method results ######################
par(mfrow=c(3,1), mar=c(1,1.4,1.4,1))

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_DOM_NJ",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "DOM",line = -0.5)
#title(main = "DOM", cex.main=2)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_CAS_NJ",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "CAS",line = -0.5)
#title(main = "CAS", cex.main=2)

barplot.input <- as.matrix(read.table(paste(path,"fiveKbTrees_MUS_NJ",sep = "")))
colnames(barplot.input) <- c()
sums <- ifelse(colSums(barplot.input)==0,1,colSums(barplot.input))
for(i in 1:nrow(barplot.input)){barplot.input[i,] <- barplot.input[i,]/sums}
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "MUS",line = -0.5)


##################################################################################
######################### Non-recombined regions tree ############################
##################################################################################
#install.packages("ape")
library(ape)
dom.col <- "darkgoldenrod1"
cast.col <- "red"
musc.col <- "coral"
t.col <- "green4"
layout(matrix(c(1,2,1,3,1,4),3,2,byrow = T))

treePhylo<-read.tree(file =paste(path,"TreeOfNonRecombinedRegions.fa.contree",sep = ""))
col.vec <- rep("black",length(treePhylo$tip.label)) #make color vector
col.vec[grep("Mmm",treePhylo$tip.label)] <- musc.col #musculus 
col.vec[grep("Mmc",treePhylo$tip.label)] <- cast.col #castaneus 
col.vec[grep("Mmd",treePhylo$tip.label)] <- dom.col #domesticus 
tIndeces<-grep("Hapl",treePhylo$tip.label)
treePhylo$tip.label[grep("Mmm_CZE",treePhylo$tip.label)] <- "CZE"
treePhylo$tip.label[grep("Mmm_KAZ",treePhylo$tip.label)] <- "KAZ"
treePhylo$tip.label[grep("Mmm_AFG",treePhylo$tip.label)] <- "AFG"
treePhylo$tip.label[grep("Mmc",treePhylo$tip.label)] <- "CAST"
treePhylo$tip.label[grep("Mmd_GER",treePhylo$tip.label)] <- "GER"
treePhylo$tip.label[grep("Mmd_FRA",treePhylo$tip.label)] <- "FRA"
treePhylo$tip.label[grep("SPR",treePhylo$tip.label)] <- "SPRE"
treePhylo$tip.label[tIndeces] <- paste("t-",treePhylo$tip.label[tIndeces],sep="")

par(mar=rep(0.5,4))
plot.phylo(root(treePhylo,outgroup=which(treePhylo$tip.label=="SPRE")),
           edge.width = 2,adj = 0.5,tip.color = col.vec,cex=1.4,font = 4,align.tip.label = 3)
nodelabels(text = treePhylo$node.label,cex=0.75,frame = "none",adj = 1.3, col="ivory4")
############################################
########## outgroup barplots ###############
############################################
#par(mar=c(1.9,4,1,1), mfrow=c(3,1), cex=1.2)

par(mar=c(4,4,1,1))
outgroup <- read.table(paste(path,"Outgroup_results_ML",sep = ""))[,2:3]
barplot(rbind(table(outgroup[,1])[c(4,2,1,3)]*100/sum(table(outgroup[,1])),table(outgroup[,2])[c(4,2,1,3)]*100/sum(table(outgroup[,1]))),
        beside = T, col=c("grey","green4"), cex.lab=1.1,names.arg = c("None", 
                                                                      expression(italic("M. m. domesticus")),
                                                                      expression(italic("M. m. castaneus")),
                                                                      expression(italic("M. m. musculus"))),
        legend.text = c(expression(paste("Non-",italic("t"),"-haplotypes")),expression(paste(italic("t"),"-haplotypes"))),
        args.legend = list(bty="n", cex=0.9,x=15,y=60), cex.names = 1.1)

outgroup <- read.table(paste(path,"Outgroup_results_MP",sep = ""))[,2:3]
barplot(rbind(table(outgroup[,1])[c(4,2,1,3)]*100/sum(table(outgroup[,1])),table(outgroup[,2])[c(4,2,1,3)]*100/sum(table(outgroup[,1]))),
        beside = T, col=c("grey","green4"), ylab = "Percent of trees", cex.lab=1.1,names.arg = c("None", 
                                                                                                 expression(italic("M. m. domesticus")),
                                                                                                 expression(italic("M. m. castaneus")),
                                                                                                 expression(italic("M. m. musculus"))),cex.names = 1.1)
par(mar=c(4.1,4,1,1))
outgroup <- read.table(paste(path,"Outgroup_results_NJ",sep = ""))[,2:3]
barplot(rbind(table(outgroup[,1])[c(4,2,1,3)]*100/sum(table(outgroup[,1])),table(outgroup[,2])[c(4,2,1,3)]*100/sum(table(outgroup[,1]))),
        beside = T, col=c("grey","green4"),xlab = "Outgroup", cex.lab=1.1,names.arg = c("None", 
                                                                                        expression(italic("M. m. domesticus")),
                                                                                        expression(italic("M. m. castaneus")),
                                                                                        expression(italic("M. m. musculus"))),cex.names = 1.1)                      

##########################################################################
##################### Deterioration ######################################
##########################################################################
barplotSFS <- as.matrix((read.table(paste(path,"DeteriorationSFS",sep = ""))))
deteriorCateg <- read.table(paste(path,"DeteriorationTable",sep = ""))
ratios <- rbind((deteriorCateg$t.ns/deteriorCateg$t.syn),deteriorCateg$s.ns/deteriorCateg$s.syn)

par(mfrow=c(1,2), mar=c(4.5,5,1,1), cex=1.5)
barplot(barplotSFS,beside = T,col=c("grey","black","green4"), ylim=c(0,1.1),
        names.arg = c("0.25", "0.5", "0.75", "1"),
        xlab = "Proportion of haplotypes carrying SNP",
        ylab = "NS / S SNP ratio",
        args.legend = list(bty="n",x=10, y=1.1,x.intersp=0.1,cex=0.9), 
        legend.text = c(expression(italic("M. m. domesticus")),
                        expression(italic("M. spretus")),
                        expression(paste(italic("t"),"-haplotype (",italic("M. m. d."),")"))
        ))
barplot(ratios,col=c("green4","black"), ylim=c(0,1.1),
        names.arg = c("None", "Recent","Very Recent"), xlab = "Recombination", 
        ylab = "NS / S fixed SNP ratio", beside = T)


                                                                                             




