#!/usr/bin/perl
my $input = $ARGV[0];

print "############################################\n";
print "Checking whether Ts of a species are outgroups of 1. species group 2. species\n";
print "In the output, 0 = outgroup, 1 = ingroup. Col 1 = tree name, col 2 = status regarding species group, col 3 = status regarding species\n";
print "the last column is the sum: 0 = dark green, 1 = light green, 2 = yellow\n";

open (INPUT, "$input"); 

#first we simplify the tree: 1 = Ms, 2 = Mmc, 3 = Mmm, 4 = Mmd
# 5 = Mmc t-carrier, 6 = Mmm t-carrier, 7 = Mmd t-carrier

system "cat $input | perl -pi -e \'s/[0-9]//gi\' | perl -pi -e \'s/[\.\:\-]//gi\' | perl -pi -e \'s/[\_]//gi\' | perl -pi -e \'s/tHapl/9/gi\' | perl -pi -e \'s/Ms/1/g\' | perl -pi -e \'s/Mmc/2/g\' | perl -pi -e \'s/Mmm/3/g\' | perl -pi -e \'s/Mmd/4/g\' | perl -pi -e \'s/[a-z]//gi\' | perl -pi -e \'s/29/5/gi\' | perl -pi -e \'s/39/6/gi\' | perl -pi -e \'s/49/7/gi\' | /Users/bvicoso/Documents/Reka/Final/Submission4_Genetics/Trees/newick-utils-1.3.0/src/nw_reroot - 1   | perl -pi -e \'s/[\;\,]//gi\'  > $input.simple";


open (INPUT2, "$input.simple"); 
open (RESULTS, ">>Tree_results_mus");

while ($line = <INPUT2>) {
	$text2=$line;
	}
$text=$text2;

print "$input: $text\n";


#let's check how many mice we have in the sample
@samples = split ("", $text);

$tmus=0;
$tdom=0;
$tcas=0;

foreach $samp (@samples)
	{ if ($samp eq "3") {$tmus=$tmus+1;}
	 elsif ($samp eq "4") {$tdom=$tdom+1;}
	 elsif ($samp eq "2") {$tcas=$tcas+1;}

	 else {}
	}
print "total mus $tmus, dom $tdom, cas $tcas\n";


##################
#################
##################

#first test whether ts are outgroups to SPECIES GROUP
print "first test whether ts are outgroups to SPECIES GROUP\n\n";

$counter=0;
$cast_group=1; #we assume that Ts are not an outgroup, and change this to 0 if they are

while ($counter==0)

{

#break text into blocks of bracketed expressions

@letters=split("", $text);
shift (@letters);
pop (@letters);
#print @letters;

@elements="";
$fcount=0;
$rcount=0;
foreach $letter (@letters)
	{
	push (@elements, $letter);
	if ($letter eq "(" )
		{
		$fcount=$fcount+1;
		}
	elsif ($letter eq ")" )
		{
		$rcount=$rcount+1;
		}
	else {}
	
	if ($letter ne "," && $fcount==$rcount) 
		{
		$element = join("", @elements);
		push (@blocks, $element);
		@elements="";
		$fcount=0;
		$rcount=0;

		}
	else {}
	}

#then test the blocks

foreach $block (@blocks)
	{
	if ($block =~ /3/)
		{
		$text=$block;

		$musc=0;
		$dom=0;
		$cas=0;
		$cast=0;

		#let's test whether Ts are nested in the species group
		#figure out whether block countains all Mus musculus individuals
		#and whether it also contains t-haplotypes
		#once we get all Mus musculus but no Ts, we can reject nesting
		
		@mice = split ("", $block);

		foreach $mouse (@mice)
			{ if ($mouse eq "3") {$musc=$musc+1;}
			 elsif ($mouse eq "4") {$dom=$dom+1;}
			 elsif ($mouse eq "2") {$cas=$cas+1;}
			 elsif ($mouse eq "6") {$cast=$cast+1;}

			 else {}
			}
print "Mice numbers t $cast m $musc c $cas d $dom\n";
		if ($cas==$tcas && $musc==$tmus && $dom==$tdom) 
			{
			if ($cast==0) {$cast_group=0;print "T is outgroup to species group!\n";} 
			else {print "T NOT OUTGROUP TO SPECIES GROUP\n";}
			}
		else {$counter=1;}
		
		}
	}

@blocks="";


}



#######################
#######################
#######################

#now test species
print "Now testing whether ts are outgroup to species\n\n";

#Let's refill $text with the full tree

$text=$text2;

print "$text\n";

$countersp=0;
$cast_species=1; #we assume that Ts are not an outgroup, and change this to 0 if they are

while ($countersp==0)

{

#break text into blocks of bracketed expressions

@letters=split("", $text);
shift (@letters);
pop (@letters);
#print @letters;

@elements="";
$fcount=0;
$rcount=0;
foreach $letter (@letters)
	{
	push (@elements, $letter);
	if ($letter eq "(" )
		{
		$fcount=$fcount+1;
		}
	elsif ($letter eq ")" )
		{
		$rcount=$rcount+1;
		}
	else {}
	
	if ($letter ne "," && $fcount==$rcount) 
		{
		$element = join("", @elements);
		push (@blocks, $element);
		@elements="";
		$fcount=0;
		$rcount=0;

		}
	else {}
	}

#then test the blocks

foreach $block (@blocks)
	{
	if ($block =~ /3/)
		{
		$text=$block;

		$musc=0;
		$dom=0;
		$cas=0;
		$cast=0;

		#let's test whether Ts are nested in the species 
		#figure out whether block countains all Mus musculus CASTANEUS individuals
		#and whether it also contains t-haplotypes
		#once we get all Mus musculus CASTANEUS but no Ts, we can reject nesting
		
		@mice = split ("", $block);

		foreach $mouse (@mice)
			{ if ($mouse eq "3") {$musc=$musc+1;}
			 elsif ($mouse eq "4") {$dom=$dom+1;}
			 elsif ($mouse eq "2") {$cas=$cas+1;}
			 elsif ($mouse eq "6") {$cast=$cast+1;}

			 else {}
			}
print "Mice numbers T $cast m $musc c $cas d $dom\n";
		if ($musc==$tmus) 
			{
			if ($cast==0) {$cast_species=0; print "T is outgroup to species!\n";} 
			else {"T NOT OUTGROUP TO SPECIES\n";}
			}
		else {$countersp=1;}
		
		}
	}

@blocks="";


}


$sum = $cast_group+$cast_species;


print RESULTS "$input $cast_group $cast_species $sum\n";

