library(stringi)
#### set path ########
path <- paste(getwd(),"/Seafile/Work/Work/T-hap-Paper-Revisions/",sep = "") ## laptop
#path <- paste(getwd(),"/Seafile/Work/T-hap-Paper-Revisions/",sep = "") ## desktop

#### software ####
# software <- "Data/TreesInWindowsOf5Kb/MaximumLikelihood_IQTree/"
# outFileEnding <- ""
# software <- "Data/TreesInWindowsOf5Kb/MaximumParsimony_Mega/"
# outFileEnding <- "_MP"
software <- "Data/TreesInWindowsOf5Kb/NeighborJoining_FastPhylo/"
outFileEnding <- "_NJ"

### which SNPs ####
#snps <- "PASS_SNPs/"
snps <- "raw_SNPs/"

##### set output path #######
output_folder <- paste(path,"DataToPlot/",snps,sep = "")


########## DOM #########
## import file ######
fiveKbTrees <- read.table(paste(path,software,snps,"Tree_results_dom_sorted",sep = ""))
#####################

barplot.input <- c()
j <- 1
for(i in 1:70){ ### for each 0.5 Mb window
  start <- (i-1)*500000 ### define start coordinate
  end <- i*500000 ### and end coordinate
  ancestries <- c() ## this will contain 0,1 or 2, for non-, recent- and very recent recombination
  smaller <- T 
  while(smaller){ 
    second <- as.numeric(stri_split(fiveKbTrees[j,1],regex = "-")[[1]][2])
    if(second<end&j<nrow(fiveKbTrees)){
     ancestries <- c(ancestries,fiveKbTrees[j,4])
    }
    else{smaller <- F}
    j <- j+1
  }
  zeros <- length(which(ancestries==0))
  ones <- length(which(ancestries==1))
  twos <- length(which(ancestries==2))

  barplot.input <- cbind(barplot.input,c(zeros,ones,twos))
}

write.table(barplot.input,file=paste(output_folder,"fiveKbTrees_DOM",outFileEnding,sep = ""),
            quote = F,row.names = F,col.names = F)
par(mfrow=c(3,1), mar=c(1,1.4,1.4,1))
barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F,names.arg =rep("",ncol(barplot.input)) )
title(ylab = "DOM",line = -0.5)

### CAS #####
## import file ######
fiveKbTrees <- read.table(paste(path,software,snps,"Tree_results_cas_sorted",sep = ""))
#####################

barplot.input <- c()
j <- 1
for(i in 1:70){
  start <- (i-1)*500000
  end <- i*500000
  ancestries <- c()
  smaller <- T
  while(smaller){
    second <- as.numeric(stri_split(fiveKbTrees[j,1],regex = "-")[[1]][2])
    if(second<end&j<nrow(fiveKbTrees)){
      ancestries <- c(ancestries,fiveKbTrees[j,4])
    }
    else{smaller <- F}
    j <- j+1
  }
  zeros <- length(which(ancestries==0))
  ones <- length(which(ancestries==1))
  twos <- length(which(ancestries==2))
  
  barplot.input <- cbind(barplot.input,c(zeros,ones,twos))
}

write.table(barplot.input,file=paste(output_folder,"fiveKbTrees_CAS",outFileEnding,sep = ""),
            quote = F,row.names = F,col.names = F)

barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "CAS",line = -0.5)

######### MUS ###########
## import file ######
fiveKbTrees <- read.table(paste(path,software,snps,"Tree_results_mus_sorted",sep = ""))
#####################

barplot.input <- c()
j <- 1
for(i in 1:70){
  start <- (i-1)*500000
  end <- i*500000
  ancestries <- c()
  smaller <- T
  while(smaller){
    second <- as.numeric(stri_split(fiveKbTrees[j,1],regex = "-")[[1]][2])
    if(second<end&j<nrow(fiveKbTrees)){
      ancestries <- c(ancestries,fiveKbTrees[j,4])
    }
    else{smaller <- F}
    j <- j+1
  }
  zeros <- length(which(ancestries==0))
  ones <- length(which(ancestries==1))
  twos <- length(which(ancestries==2))
  
  barplot.input <- cbind(barplot.input,c(zeros,ones,twos))
}

write.table(barplot.input,file=paste(output_folder,"fiveKbTrees_MUS",outFileEnding,sep = ""),
            quote = F,row.names = F,col.names = F)

barplot(barplot.input, col = c("green4","light green","darkgoldenrod1"), axes = F)
title(ylab = "MUS",line = -0.5)


